#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "bignum.h"
#include "util.h"

/* Returns true if OK, false otherwise. */
int
bnum_ensure_len(struct bignum *bn, int len)
{
	unsigned short *tmp;

	assert(bn != NULL);

	if (len == 0)
		return 1;

	if (bn->len >= len)
		return 1;

	tmp = realloc(bn->val, len*sizeof(unsigned short));

	if (tmp == NULL)
		return 0;
	
	bn->val = tmp;

	memset(bn->val + bn->len, 0,
	       (len - bn->len) * sizeof(unsigned short));

	bn->len = len;
	return 1;
}

